/*
polyprint.v1

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package polyprintapi

import (
	"encoding/json"
)

// checks if the PolyprintContactAddress type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &PolyprintContactAddress{}

// PolyprintContactAddress struct for PolyprintContactAddress
type PolyprintContactAddress struct {
	CountryId interface{} `json:"countryId,omitempty"`
	Street interface{} `json:"street,omitempty"`
	ZipCode interface{} `json:"zipCode,omitempty"`
	City interface{} `json:"city,omitempty"`
	State interface{} `json:"state,omitempty"`
	HouseNo interface{} `json:"houseNo,omitempty"`
}

// NewPolyprintContactAddress instantiates a new PolyprintContactAddress object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewPolyprintContactAddress() *PolyprintContactAddress {
	this := PolyprintContactAddress{}
	return &this
}

// NewPolyprintContactAddressWithDefaults instantiates a new PolyprintContactAddress object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewPolyprintContactAddressWithDefaults() *PolyprintContactAddress {
	this := PolyprintContactAddress{}
	return &this
}

// GetCountryId returns the CountryId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *PolyprintContactAddress) GetCountryId() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.CountryId
}

// GetCountryIdOk returns a tuple with the CountryId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *PolyprintContactAddress) GetCountryIdOk() (*interface{}, bool) {
	if o == nil || IsNil(o.CountryId) {
		return nil, false
	}
	return &o.CountryId, true
}

// HasCountryId returns a boolean if a field has been set.
func (o *PolyprintContactAddress) HasCountryId() bool {
	if o != nil && IsNil(o.CountryId) {
		return true
	}

	return false
}

// SetCountryId gets a reference to the given interface{} and assigns it to the CountryId field.
func (o *PolyprintContactAddress) SetCountryId(v interface{}) {
	o.CountryId = v
}

// GetStreet returns the Street field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *PolyprintContactAddress) GetStreet() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.Street
}

// GetStreetOk returns a tuple with the Street field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *PolyprintContactAddress) GetStreetOk() (*interface{}, bool) {
	if o == nil || IsNil(o.Street) {
		return nil, false
	}
	return &o.Street, true
}

// HasStreet returns a boolean if a field has been set.
func (o *PolyprintContactAddress) HasStreet() bool {
	if o != nil && IsNil(o.Street) {
		return true
	}

	return false
}

// SetStreet gets a reference to the given interface{} and assigns it to the Street field.
func (o *PolyprintContactAddress) SetStreet(v interface{}) {
	o.Street = v
}

// GetZipCode returns the ZipCode field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *PolyprintContactAddress) GetZipCode() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.ZipCode
}

// GetZipCodeOk returns a tuple with the ZipCode field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *PolyprintContactAddress) GetZipCodeOk() (*interface{}, bool) {
	if o == nil || IsNil(o.ZipCode) {
		return nil, false
	}
	return &o.ZipCode, true
}

// HasZipCode returns a boolean if a field has been set.
func (o *PolyprintContactAddress) HasZipCode() bool {
	if o != nil && IsNil(o.ZipCode) {
		return true
	}

	return false
}

// SetZipCode gets a reference to the given interface{} and assigns it to the ZipCode field.
func (o *PolyprintContactAddress) SetZipCode(v interface{}) {
	o.ZipCode = v
}

// GetCity returns the City field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *PolyprintContactAddress) GetCity() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.City
}

// GetCityOk returns a tuple with the City field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *PolyprintContactAddress) GetCityOk() (*interface{}, bool) {
	if o == nil || IsNil(o.City) {
		return nil, false
	}
	return &o.City, true
}

// HasCity returns a boolean if a field has been set.
func (o *PolyprintContactAddress) HasCity() bool {
	if o != nil && IsNil(o.City) {
		return true
	}

	return false
}

// SetCity gets a reference to the given interface{} and assigns it to the City field.
func (o *PolyprintContactAddress) SetCity(v interface{}) {
	o.City = v
}

// GetState returns the State field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *PolyprintContactAddress) GetState() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.State
}

// GetStateOk returns a tuple with the State field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *PolyprintContactAddress) GetStateOk() (*interface{}, bool) {
	if o == nil || IsNil(o.State) {
		return nil, false
	}
	return &o.State, true
}

// HasState returns a boolean if a field has been set.
func (o *PolyprintContactAddress) HasState() bool {
	if o != nil && IsNil(o.State) {
		return true
	}

	return false
}

// SetState gets a reference to the given interface{} and assigns it to the State field.
func (o *PolyprintContactAddress) SetState(v interface{}) {
	o.State = v
}

// GetHouseNo returns the HouseNo field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *PolyprintContactAddress) GetHouseNo() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.HouseNo
}

// GetHouseNoOk returns a tuple with the HouseNo field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *PolyprintContactAddress) GetHouseNoOk() (*interface{}, bool) {
	if o == nil || IsNil(o.HouseNo) {
		return nil, false
	}
	return &o.HouseNo, true
}

// HasHouseNo returns a boolean if a field has been set.
func (o *PolyprintContactAddress) HasHouseNo() bool {
	if o != nil && IsNil(o.HouseNo) {
		return true
	}

	return false
}

// SetHouseNo gets a reference to the given interface{} and assigns it to the HouseNo field.
func (o *PolyprintContactAddress) SetHouseNo(v interface{}) {
	o.HouseNo = v
}

func (o PolyprintContactAddress) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o PolyprintContactAddress) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.CountryId != nil {
		toSerialize["countryId"] = o.CountryId
	}
	if o.Street != nil {
		toSerialize["street"] = o.Street
	}
	if o.ZipCode != nil {
		toSerialize["zipCode"] = o.ZipCode
	}
	if o.City != nil {
		toSerialize["city"] = o.City
	}
	if o.State != nil {
		toSerialize["state"] = o.State
	}
	if o.HouseNo != nil {
		toSerialize["houseNo"] = o.HouseNo
	}
	return toSerialize, nil
}

type NullablePolyprintContactAddress struct {
	value *PolyprintContactAddress
	isSet bool
}

func (v NullablePolyprintContactAddress) Get() *PolyprintContactAddress {
	return v.value
}

func (v *NullablePolyprintContactAddress) Set(val *PolyprintContactAddress) {
	v.value = val
	v.isSet = true
}

func (v NullablePolyprintContactAddress) IsSet() bool {
	return v.isSet
}

func (v *NullablePolyprintContactAddress) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullablePolyprintContactAddress(val *PolyprintContactAddress) *NullablePolyprintContactAddress {
	return &NullablePolyprintContactAddress{value: val, isSet: true}
}

func (v NullablePolyprintContactAddress) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullablePolyprintContactAddress) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


